with GNATCOM.IInterface;

with GNATCOM.Errors;

package body MSHTML.IHTMLDOMAttribute4_Interface is

   procedure Initialize (This : in out IHTMLDOMAttribute4_Type) is
   begin
      Set_IID (This, IID_IHTMLDOMAttribute4);
   end Initialize;

   function Pointer (This : IHTMLDOMAttribute4_Type)
     return Pointer_To_IHTMLDOMAttribute4
   is
   begin
      return To_Pointer_To_IHTMLDOMAttribute4 (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLDOMAttribute4_Type;
                     Pointer : in     Pointer_To_IHTMLDOMAttribute4)
   is
   begin
      Attach (This, GNATCOM.IInterface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_nodeValue
     (This : IHTMLDOMAttribute4_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_nodeValue
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_nodeValue;

   function Get_nodeValue
     (This : IHTMLDOMAttribute4_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_nodeValue
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_nodeValue;

   function Get_nodeName
     (This : IHTMLDOMAttribute4_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_nodeName
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_nodeName;

   function Get_name
     (This : IHTMLDOMAttribute4_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_name
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_name;

   procedure Put_value
     (This : IHTMLDOMAttribute4_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_value
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_value;

   function Get_value
     (This : IHTMLDOMAttribute4_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_value
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_value;

   function Get_firstChild
     (This : IHTMLDOMAttribute4_Type)
     return Pointer_To_IHTMLDOMNode
   is
       RetVal : aliased Pointer_To_IHTMLDOMNode;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_firstChild
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_firstChild;

   function Get_lastChild
     (This : IHTMLDOMAttribute4_Type)
     return Pointer_To_IHTMLDOMNode
   is
       RetVal : aliased Pointer_To_IHTMLDOMNode;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_lastChild
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_lastChild;

   function Get_childNodes
     (This : IHTMLDOMAttribute4_Type)
     return GNATCOM.Types.Pointer_To_IDispatch
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IDispatch;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_childNodes
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_childNodes;

   function hasAttributes
     (This            : IHTMLDOMAttribute4_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.hasAttributes
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end hasAttributes;

   function hasChildNodes
     (This      : IHTMLDOMAttribute4_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.hasChildNodes
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end hasChildNodes;

   procedure normalize
     (This : IHTMLDOMAttribute4_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.normalize
         (Pointer (This)));

   end normalize;

   function Get_specified
     (This : IHTMLDOMAttribute4_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_specified
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_specified;

end MSHTML.IHTMLDOMAttribute4_Interface;

